#Picaxe 18M2

;Frankenstein board drive by Steve Bjork

	
; ******** NOTHING BELOW THIS LINE NEEDS TO BE EDIT ********

'Change Log
;Version 9.1.2    June 15, 2014
;Added code in setup to make sure min and max range on servos are set with the min smaller than max range data.

;Verion 9.1.1     June 11, 2014
; Uses hserout (in place of serout) for talking to MP-3 player.  (Help to remove servo jittier)
;DISABLEBOD added at start to disable the on-chip brown out detect function to help with servo jittier

;New version number is based on Board.Software.Update
; Version 9.1.0 -       May-1-2014
;This is for version 9 board, Software version 1 (First release) and no update.


;Switch to 16 fix point math for turn position and speed for movement vector

; Version 0.7.0 -       Mar-13-2014
;Using version 6.0 program editor
;Remove Random Seed option from board.
;cleaned up code and comments
;fix bugs in head movement code (right/left turn was swaped)


; Version 0.6.1	-	Mar-07-2014
;Command select was not picking the Head Nod No command.  (Would not select the 7 command.)
;Returned Inertia setting back to 16 MhZ speed again
;Fix bug so board will enter SETUP mode.

; Version 0.6.0	-	Mar-07-2014
;Remove hardware serial I/O to MP-3 player because of interference with servo (Jitter)
;Return to 16 MHz speed for after servo movement and needed for 4800 baud for MP-3 player

' Version 0.5.4	 -	Mar-05-2014  
;recoded software to work a standard clock speed of m4
;Working removeing jitter and head speed.

' Version 0.5.3	 -	Mar-04-2014  
;Added Random command to trigger loop to make random more random (Only done when Random seed was selected from menu.) 
;Added 1 minute trigger delay on board power up when Negative  or Positive trigger is selected.
;Fix bug in waiting for trigger section.
;Fix eeprom pointer system


'Creative Commons License - Attribution-NonCommercial-ShareAlike 3.0 Unported
'THE WORK IS PROVIDED UNDER THE TERMS OF THIS CREATIVE COMMONS PUBLIC LICENSE ("CCPL" OR "LICENSE").
'THE WORK IS PROTECTED BY COPYRIGHT AND/OR OTHER APPLICABLE LAW. ANY USE OF THE WORK OTHER THAN AS
'AUTHORIZED UNDER THIS LICENSE OR COPYRIGHT LAW IS PROHIBITED.
'BY EXERCISING ANY RIGHTS TO THE WORK PROVIDED HERE, YOU ACCEPT AND AGREE TO BE BOUND BY THE TERMS OF THIS LICENSE.
'TO THE EXTENT THIS LICENSE MAY BE CONSIDERED TO BE A CONTRACT, THE LICENSOR GRANTS YOU THE RIGHTS CONTAINED HERE
'IN CONSIDERATION OF YOUR ACCEPTANCE OF SUCH TERMS AND CONDITIONS.
'See this link for the complete license http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode

'The bottom line, the license lets you reprogramming, tweak, and build upon this work for non-commercial use
'as long as you give credit and license your new creations under the identical terms.  Go have fun with it.


;The board used the pot to select what option and the setup button to set the option.  The MP-3 player will speak to the user
;and guide them.


;I/O port setup

symbol dirbSetup	= %01100111
symbol dircSetup	= %01001000

symbol HeadTurnServo    = B.0   ;This port talks to the servo controlling head turn
symbol HeadTurnNum      = 0     ;The code number for this servo

symbol HeadNodServo     = B.1   ;This Port talks to the servo controlling head nod
symbol HeadNodNum       = 1     ;The code number for this servo

symbol HeadTiltServo    = B.2   ;This port talks to the servo controlling head tilt
symbol HeadTiltNum      = 2     ;The code number for this servo

symbol EyesOutput       = B.7   ;TLL level out for when the board is talking.  High (1) when talking

symbol MP3SerialOutPort = B.5   ;Serial Out to MP3 player module
symbol MP3StatusPort    = C.1   ;Busy input from Module, use ADC levels
symbol MP3StatusPin     = pinC.1 ;name for pin
	
symbol SetupLED 	= C.6   ;Red LED for setup mode status light.
symbol SetupPot 	= C.0   ;for Analog input from 0 to 5 volt from wiper on 10K setup pot
symbol SetupButtonPin   = pinC.5 ;Pin for Button use in setup mode
	
Symbol MOSFEToutput     = B.6   ;MOSFET output
	
Symbol TriggerInput     = C.7   ;Motion trigger
Symbol TriggerInputPin  = pinC.7 ;Motion trigger pin

;C.3 and C.4 are used for programming and debug.

;I/O pins not used by the software
;B.3, B.4, C.2, C.4

;The Head Movement variable (working from the end of Variables)
;Since Head turn will always be a whole number, we will just use 8 Bit for the position and speed.

;symbol TurnPos         = b27   ;Head Turning position
symbol TurnPos_Word     = w13   ;Head Turning position *256
symbol TurnPos_LSB      = b26   ;Head Turning position fraction (byte)
symbol TurnPos_MSB      = b27   ;Head Turning position whole number (byte)

;symbol TurnSpeed	= b26   ;Head Turning Speed
symbol TurnSpeed_Word    = w12   ;Head Turning Speed *256
symbol TurnSpeed_LSB     = b24   ;Head Turning Speed fraction (byte)
symbol TurnSpeed_MSB     = b25   ;Head Turning Speed whole number (byte)

symbol NodPos_Word      = w11   ;Head Nodding position *256
symbol NodPos_LSB       = b22   ;Head Nodding position fraction (byte)
symbol NodPos_MSB       = b23   ;Head Nodding position whole number (byte)

symbol NodSpeed_Word    = w10   ;Head Nodding Speed *256
symbol NodSpeed_LSB     = b20   ;Head Nodding Speed fraction (byte)
symbol NodSpeed_MSB     = b21   ;Head Nodding Speed whole number (byte)

symbol TiltPos_Word     = w9   ;Head Tilting position *256
symbol TiltPos_LSB      = b18   ;Head Tilting position fraction (byte)
symbol TiltPos_MSB      = b19   ;Head Tilting position whole number (byte)

symbol TiltSpeed_Word   = w8    ;Head Tilting Speed *256
symbol TiltSpeed_LSB    = b16   ;Head Tilting Speed fraction (byte)
symbol TiltSpeed_MSB    = b17   ;Head Tilting Speed whole number (byte)

;General Variables used by the code (Start with b0/w0)

symbol Random_Word      = w0    ;used to hold the pseudo-random number  (word access)
symbol Random_LSB       = b0    ;The lower 8-bits of the Random Word
symbol Random_MSB       = b1    ;The upper 8 bits of the Random Word

symbol Temp_Word	= w1    ;Temp variable (Word Access)
symbol Temp_LSB 	= b2    ;Temp variable (Lower 8 bits of word)
symbol Temp_MSB 	= b3    ;Temp variable (Upper 8 bits of word)

symbol WaitingMode      = b4    ;Modes for talking (MP-3) system
symbol MovementCount    = b5    ;the number times the vector lood should run
symbol MovementDelay    = b6    ;The number of ms the vector loop should pause on each loop
symbol LastCommand      = b7    ;last movement command ran

symbol TrackPlaying     = b8    ;the track playing ID number

;Local Variables used to setup the movement code
symbol NewTurnPos       = b9   ;New left/right position to travel to.
symbol CenterTurnPos    = b10   ;the center position for left/right axes
Symbol CenterTiltPos    = b11   ;Center tilt Position
symbol CenterNodPos     = b12   ;Center Nod Position
symbol NewTiltPos       = b13   ;Where to tilt to in this movement
symbol NewNodPos	= b14   ;where to nod to


;Local Variables used by Vector movement code.
symbol VectorIndex      = b9   ;This is use as the index for the For:Next loop of Vector movement sub.
symbol Inertia  	= b10   ;This is the starting & ending inertia so the head has weight
symbol LastTurn 	= b11   ;The last position sent to Turn servo
symbol LastTilt 	= b12   ;The last position sent to Tilt servo
symbol LastNod  	= b13   ;The last position sent to Nod servo

;b15 not used by main code

;Local Veriables used by Setup Menu System

symbol DataPointer      =b4     ;for eeprom read pointer
symbol PotRead  	=b5     ;The Current ADC reading of pot 0-255
symbol LastPotreading   =b6     ;hold the last reading from the ADC pot.
symbol ItemNumber       =b7     ;0 to (n-1) of pot value converted to item number
symbol LastItemNumber   =b8     ;the last item number created.

symbol TalkNumber       =b9     ;Hold the track number to talk via the MP-3
symbol CodeToRun	=b10    ;
symbol ItemCount	=b11    ;# of items in Input
symbol TalkItem 	=b12    ;First Talk item for first item input
symbol EEPROMpointer    =b13    ;points to EEPROM record for this servo's record data.
symbol ServoCounter     =b14    ;for/next counter

symbol ThisServo	=b15    ;the servo we are adjusting
symbol ThisServoPin     =b16    ;the pin number of servo we are adjusting
symbol ThisEEPROM       =b17    ;the part of the eeprom we are adjusting


;Used by by Trigger next play of MP3 file
symbol ElapsedTime      = s_w7  ;(word) System's elapsed time counter in seconds

symbol MP3RootFolder    =241    ;MP-3 player's command for root folder
symbol MP3MenuFolder    =242    ;MP-3 player's command for Menu Audio folder
symbol MP3StopPlay      =235    ;MP-3 plyaer stop command
symbol MP3VolumeSet     =227    ;Set MP-3 player's volume to start level of 27 out of 31 or 84%

;Modes for runtime talking (mp-3 player)
symbol WaitingForTrigger	=0      ;waiting for trigger to start talking.
symbol WaitingForNotBusy	=1      ;Wait for not busy (done talking)
symbol WaitingForTime   	=2      ;Waiting for time delay before next trigger.

;List of movement type commands called be main code...

symbol HeadLookHome       =0    ;Sends Head to home turn, Tilt and Nod position
symbol HeadLookFarLeft    =1    ;Sends head to far left turn
symbol HeadLookNearLeft   =2    ;Sends Head to near left turn
symbol HeadLookFarRight   =3    ;Sends head to Far right turn
symbol HeadLookNearRight  =4    ;Sends head to near Right Turn
symbol HeadLookAt 	=5    ;Tells head to tilt list its looking at something
symbol HeadNodNo  	=6    ;Shakes head back and forward for a "no" answer


symbol ServoMin=75      ;min servo position setting
symbol ServoMax=225     ;max servo position setting
symbol ServoRange=ServoMax-ServoMin     ;max range of servo

;Range for Program Pot near center and used by Menu system
symbol CenterMinPot=110 		;Lowest number for center on pot range
symbol CenterMaxPot=150 		;Highest number for center pot range


;There are the Trigger type mode for looking at PIR
symbol TriggerTypeAuto=0	;Just auto (re) trigger the voice track
symbol TriggerTypePos =1	;Wait for input to go high to trigger voice
symbol TriggerTypeNeg =2	;wait for input to go low to trigger voice


;Audio prompts for menus

symbol TalkSetupWelcome 	=001    ;"Welcome to setup mode"
symbol TalkSetupMenu    	=002    ;"Please turn the setup potentiometer to select the setup item and press the setup button"
symbol TalkServosLimits 	=003    ;"Servos limits"
symbol TalkBoardOptions 	=004    ;"Board Options"
symbol TalkExitSetupMenu	=005    ;"Exit Setup Menu"

symbol TalkSetupServos  	=006    ;"Servo Setup mode"

symbol TalkSettingNod   	=007    ;"Setting the Head Nod Servo's range."
symbol TalkSetupNodeCenter      =008    ;"Adjust the setup potentiometer till the Nod servo is in the center position and then press the Setup button."
symbol TalkSetupNodeUp  	=009    ;"Now, adjust the Nod servo to the top most position and press the button."
symbol TalkSetupNodeDown	=010    ;"Now, adjust the Nod servo to the bottom most position and press the button."

symbol TalkSettingTurn  	=011    ;"Setting the Head Turn Servo's range."
symbol TalkSetupTurnCenter      =012    ;"Adjust the setup potentiometer till the Turn servo is in the center position and then press the Setup button."
symbol TalkSetupTurnLeft	=013    ;"Now, adjust the Turn servo to the right most position and press the button."
symbol TalkSetupTurnRight       =014    ;"Now, adjust the Turn servo to the left most position and press the button."

symbol TalkSettingTilt  	=015    ;"Setting the Head Tilt Servo's range."
symbol TalkSetupTillStraight    =016    ;"Adjust the setup potentiometer till the Tilt servo is in the straight and then press the Setup button."
symbol TalkSetupTiltLeft	=017    ;"Now, adjust the Tilt servo to the right most position and press the button."
symbol TalkSetupTiltRight       =018    ;"Now, adjust the Tilt servo to the left most position and press the button."

symbol TalkEndServoSetup	=019    ;"Servo adjustments completed, returning to the main setup menu."
symbol TalkCenterPot    	=020    ;"Please adjust setup potentiometer to the center position to continue."
symbol TalkReleaseButton	=021    ;"Please release the setup button to continue."
symbol TalkEndSetupMenu 	=022    ;"Leaving setup menu and restarting the controller board."

symbol TalkBoardOptionsMenu     =023    ;"Board Options Menu, again use the setup potentiometer to select the option and press the button"
symbol TalkRamdomSeedOption     =024    ;"Ramdom Seed option"
symbol TalkTracksoption 	=025    ;"Number of Tracks option"
symbol TalkDelayOption  	=026    ;"Prop cycle delay option"
symbol TalkTalkTiggeredOption   =027    ;"Type of Talk Trigger"
symbol TalkExitMenu     	=028    ;"Exit Board Setup Menu"

symbol TalkOption       	=029    ;"Option"
symbol TalkSelected     	=030    ;"Selected

symbol TalkTrackMenu    	=031    ;"Use potentiometer to select the number of Audio tracks on SD card"
symbol TalkTrack1       	=032    ;"one"
symbol TalkTrack2       	=033    ;"two"
symbol TalkTrack3       	=034    ;"three"
symbol TalkTrack4       	=035    ;"four"
symbol TalkTrack5       	=036    ;"five"
symbol TalkTrack6       	=037    ;"six"
symbol TalkTrack7       	=038    ;"seven"
symbol TalkTrack8       	=039    ;"eight"
symbol TalkTrack9       	=040    ;"nine"
symbol TalkTrack10      	=041    ;"ten"

symbol TalkDelayOptionMenu      =042    ;"Use the potentiometer to select the delay time till the next prop cycle"
symbol Talk5Seconds     	=043    ;"5 seconds"
symbol Talk10Seconds    	=044    ;"10 seconds"
symbol Talk15Seconds    	=045    ;"15 seconds"
symbol Talk20Seconds    	=046    ;"20 seconds"
symbol Talk30Seconds    	=047    ;"30 seconds"
symbol Talk45Seconds    	=048    ;"45 seconds"
symbol Talk60Seconds    	=049    ;"60 seconds"
symbol Talk90Seconds    	=050    ;"90 seconds"
symbol Talk2Minutes     	=051    ;"2 Minutes"
symbol Talk3Minutes     	=052    ;"3 Minutes"
symbol Talk4Minutes     	=053    ;"4 Minutes"
symbol Talk5Minutes     	=054    ;"5 Minutes"
symbol Talk7Minutes     	=055    ;"7 Minutes"
symbol Talk10Minutes    	=056    ;"10 Minutes"

symbol TalkThankYou     	=057    ;"Thank you"

symbol TalkRamdomSeedMenu       =058    ;"Use potentiometer to select the reseting of the seed or select a new random seed."
symbol TalkResetSeedOption      =059    ;"Reset Seed"
symbol TalkNewSeedOption	=060    ;"New Random Seed"3

symbol TalkTriggerMenu  	=061    ;"Use the potentiometer to select the Trigger type for prop
symbol TalkJustDelayOption      =062    ;"Auto Start option"
symbol TalkPosTriggeroption     =063    ;"Positive Tigger option"
symbol TalkNegTriggerOption     =064    ;"Negative trigger option"



;This index table list the location of the data in the table (Do not edit this information)
symbol HeadCenter       =0      ;index to Head center position (Turn, Tilt & Nod)
symbol HeadMin  	=1      ;index to Head Min position (Turn, Tilt & Nod)
symbol HeadMax  	=2      ;index to Head Max position (Turn, Tilt & Nod)

symbol HeadTurnData     =0      ;index to Head Turn data
symbol HeadTiltData     =3      ;index to Head Tilt data
symbol HeadNodData      =6      ;index to Head Nod Data
symbol HeadDelayMin     =9      ;index to min head delay per loop (8-bit)
symbol HeadDelayMax     =10     ;index to Max Head Delay per loop (8-bit)
symbol HeadNodNoSpeed   =11     ;index to speed for how fast to nod no
symbol HeadTiltRate     =12     ;index to how much the head Tilts as it turns left/right (Tilt/Turn)*256
symbol HeadNodRate      =13     ;Index to how much the head Nods as it turns left right (Nod/Turn)*256
symbol HeadDataSize     =14     ;size of the each head movement type data block

Symbol HeadEEPROMpointer = 0    ;location in EEPROM of the first record of servo data

symbol EEPROMHeadTurn   =HeadTurnData
symbol EEPROMHeadTilt   =HeadTiltData
symbol EEPROMHeadNod    =HeadNodData
symbol EEPROMHeadDelayMin = HeadDelayMin
symbol EEPROMHeadTiltRate =HeadTiltRate

;this is movement data for type 0, Head moving while input is low
	data    (110,085,140)   ;Head Turn center, min range, max range, home position
	data    (161,105,198)   ;Head Tilt center, min range, max range, home position
	data    (121,113,145)   ;Head Nod center, min range, max range, home position
	data    (40,75,22)      ;Min and range of delay per loop (speed of monvement) and speed to nod head no
	data    (128,255)	;tilt and Nod factor for moving head left/right from center

	
;System setup eeprom data

Symbol eepromRandomSeed = HeadDataSize
	Data eepromRandomSeed,(1,0)	;Random seed (word) and Flag for make very random (0=no)

Symbol eepromTrackCount = eepromRandomSeed+3
	data eepromTrackCount,(1)					;number of tracks to play

symbol eepromTriggerDelay = eepromTrackCount+1
	Data (251,255)							;The delay code till next trigger of playback
	
symbol eepromTriggerType =eepromTriggerDelay+2
	Data eepromTriggerType,(0)					;Default to auto playback

symbol eepromTimeIndexTable = eepromTriggerType+1

	data eepromTimeIndexTable,(251,255, 246,255, 235,255, 226,255, 211,255, 192,255, 166,255)	;5,10,20,30,45,60,90
	data (136,255, 076,255, 016,255, 212,254, 092,254, 168,253) ;2min, 3min, 4 min 5 min, 7 min 10 min
	
symbol eepromSetServoData = eepromTimeIndexTable+26	

symbol CodeSetupMenu    	=0      ;Do commands for setup menu
symbol CodeBoardOptionsMenu     =1      ;Do commands for Board setup menu
symbol CodeTrackMenu    	=2
symbol CodeDelayMenu    	=3

	
	data eepromSetServoData,(TalkSettingNod,HeadNodNum,HeadNodServo,EEPROMHeadNod)
	data (TalkSettingTurn,HeadTurnNum,HeadTurnServo,EEPROMHeadTurn)
	data (TalkSettingTilt,HeadTiltNum,HeadTiltServo,EEPROMHeadTilt)
	
symbol eepromMenuBase      =eepromSetServoData+12

;Each entry in the audio menu table is 4 bytes as follows..

; 0 - Audio File number for menu
; 1 - index for code to run when when button is pressed
; 2 - Number of options. 0= just return the number from pot 0-255, else return 0 to N-1 based on the pot position
; 3 - First test to speak for pot input.  IF 0, don't speak and anything while tunning pot.
symbol TabRecordSize    =4

symbol eepromSetupMenu =eepromMenuBase
symbol eepromBoardMenu = 4 + eepromMenuBase
symbol eepromBoardTrack = 8 + eepromMenuBase
symbol eepromBoardDelay = 12 + eepromMenuBase
symbol eepromBoardTrigger = 16+ eepromMenuBase


;Main setup menu to select the sub setup items to run

	data   eepromMenuBase,(TalkSetupMenu,CodeSetupMenu,3,TalkServosLimits)  	;Setup menu
	data (TalkBoardOptionsMenu,CodeBoardOptionsMenu,4,TalkTracksoption)     	;board options menu
	data (TalkTrackMenu,CodeTrackMenu,10,TalkTrack1)
	data (TalkDelayOptionMenu,CodeDelayMenu,14,Talk5Seconds)
	data (TalkTriggerMenu,CodeDelayMenu,3,TalkJustDelayOption)

;This next section does a full cold boot of the code
;Need to inti Variables to get thing going 
Start:
	setfreq m16     		;Run at 4 times speed
;Setup I/O pins.
	dirsB = dirbSetup       	;set I/O of the B & C pins
	dirsC = dircSetup

	low MOSFEToutput		;make sure mosfet is turned off.
	high MP3SerialOutPort   	;Make the serial line for the MP3 player as output & high
	hsersetup B4800_16,%10000
	DISABLEBOD  			;Disable the on-chip brown out detect function to help with servo jittier
	pause 500       		;pause .5 seconds to let everythihg power up

;Get the Random Seed from eeprom storage
	read eepromRandomSeed,WORD Random_Word  ;load up random seed from storage.

;Diring this next section, the Programming LED (red) will flash for about 6 seconds
;It let the MP-3 player boot and give the user times to press the SETUP button for SETUP mode
	for Temp_LSB= 1 to 13	;Pause to let the MP-3 player power up
		High SetupLED   	;Turn LED on	
		pause 500       	;wait for 1/2 second
		Low  SetupLED   	;turn off LED
		pause 500       	;wait for 1/2 second
	next Temp_LSB   		;loop till all done
	High SetupLED   		;turn

;Need to init the MP-3 player by doing a force stop twice and reset the volume.
	Temp_MSB=MP3StopPlay    	;force a MP3 Module stop
	gosub DoSFXCommand     	;send sound command and pause for 300 ms
	Temp_MSB=MP3StopPlay    	;force a MP3 Module stop twice
	gosub DoSFXCommand     	;send sound command and pause for 300 ms
	Temp_MSB=MP3VolumeSet   	;set MP-3 player's volume
	gosub DoSFXCommand     	;send sound command and paus for 300 ms
	

;Check is the SETUP buttin is pressed for SETUP mode
	if SetupButtonPin=1 then StartSetup     ;if setup button is pressed during reset then start setup (init)

;This code initi all the stuff need to make the random head movement work.
StartHeadMovement:

	low  SetupLED   		;Make sure the programming LED is off

	read eepromRandomSeed,WORD Random_Word ;load up random seed from eeprom storage.
	
;More MP-3 player Init stuff
	Temp_MSB=MP3RootFolder  	;select the audio folder that holds tracks for playing
	gosub DoSFXCommand
	

;Now, init the random head movement code

	LastCommand=255 		;Make last command a command that never could ever happen.

;Create a symbol that pointer to the data in eeprom storage that we need
;This is need since the read command can only use a variable or symbol.  No math can be used.

;Load from eeprom stroage the center position for all servos.

symbol HeadTurnCenterPointer=HeadTurnData+HeadCenter    ;do cal to get location of turn center position
	Read HeadTurnCenterPointer,TurnPos_MSB  	;get default center position for servo
	servo HeadTurnServo,TurnPos_MSB 		;and setup servo with it
	TurnPos_LSB=128 				;make it x.5 for round off

symbol HeadNodCenterPointer=HeadNodData+HeadCenter      ;do cal to get location of nod center position
	Read HeadNodCenterPointer,NodPos_MSB    	;get default center position for servo
	servo HeadNodServo,NodPos_MSB   		;and setup servo with it
	NodPos_LSB=128  				;make it x.5 for round off

symbol HeadTiltCenterPointer=HeadTiltData+HeadCenter    ;do cal to get location of Tilt center position
	read HeadTiltCenterPointer,TiltPos_MSB  	;get default center position for servo
	servo HeadTiltServo,TiltPos_MSB 		;and setup servo with it
	TiltPos_LSB=128 				;make it x.5 for round off

;Tell the code that you waiting for a the time to run out before looking for the next trigger.
	WaitingMode=WaitingForTime      	;reset the talk/MP-3 to waiting for time mode

	read eepromTriggerType,Temp_LSB 	;get the Trigger type for PIR
	if Temp_LSB=TriggerTypeAuto then	;Is it auto trigger type mode?
		time=-1 			;yes, than set time delay to only 1 second
	else
		Time=-60			;No, then set the time delay to -60 seconds for PIR to setup
	endif
	
	TrackPlaying=1  			;start with first track on MP-3




;Here we are at the main loop code.
;First up is the call to look for something like Trigger, end of track playing or Time delay is over.

main:

;First off, do the code for running the MP-3 player by doing one of its 3 modes.
	on WaitingMode gosub FindTrigger,FindEndTrack,FindTimesUp
	
;Now let select the next random head movement command.

SelectCommand:
	Random Random_Word      			;get next random number used on selecting a head command
	
;Now select the next random movement.
	if WaitingMode=WaitingForNotBusy then   	;are we playing (talking) a track?
		Temp_LSB=HeadLookAt     		;set max to Head Look At
	else
		Temp_LSB=HeadNodNo      		;Set max head command to include NOD no
	endif
	Temp_LSB=Temp_LSB+1 * Random_LSB / 256   	;get random head command, 0 to top head command of this mode.
	
	if LastCommand = Temp_LSB then SelectCommand    ;Loop back for another command if repeating the last one.

;Check if we are runing a tilt or nod no right after another tilt or nod no.
	if LastCommand>=HeadLookAt then 		;was the last command a Look at (Tilt) or Nod no?
		if Temp_LSB>=HeadLookAt then SelectCommand	;select a new command is this new is a tilt or nod no too
	endif
;run this new head command
	LastCommand = Temp_LSB  			;Remember this comamnd and run it.

	On LastCommand gosub LookHome,LookFarLeft,LookNearLeft,LookFarRight,LookNearRight,LookAt,NodNo
	Goto Main       				;after running head movement, run main loop again.


;This section handles the 3 states of the WaitingMode for running the MP-3 player for talking.

;First up is the waiting for trigger input to start talking 

FindTrigger:

	Random Random_Word      			;call random while waiting for tigger to make it more random.


	read eepromTriggerType,Temp_MSB 		;get the trigger mode from Eeprom storage.
	Temp_LSB=TriggerInputPin			;get trigger input pin status
	
	if Temp_MSB=0 then      			;is trigger mode set to auto start without tigger?
		Temp_LSB=1      			;yes, then make sure it tigger this time showing a trigger input
		
	elseif Temp_MSB=3 then  			;is it a negative trigger type?
		Temp_LSB=1-Temp_LSB     		;yes, then flip the trigger imput bit
	endif

	if Temp_LSB = 1 then    			;did we get a trigger to start talking?
	
		inc WaitingMode 			;yes, move to next waiting for mode

		Temp_LSB=TrackPlaying   		;tell MP-3 player to talk with this track.
		gosub DoTalkCommand     		;send to MP-3 player

		High MOSFEToutput       		;turn on lights
		High EyesOutput 			;turn on TTL output
	
		inc TrackPlaying			;move to next track for next time.
		read eepromTrackCount,Temp_LSB  	;get the max number of tracks stored in EEPROM
		if TrackPlaying>Temp_LSB then   	;have we move past the max number of tracks?
			TrackPlaying=1  		;If yes, then reset back to the first track
		endif
	endif
	return  					;and exit.

;This code wait for the track to end and start the timer till the next cycle
;time will be set with the negative number of the time to wait.  Once the system
;time counts up to a positive number, the code will end this mode and start
;waiting for the mext talk trigger.

FindEndTrack:
	if MP3StatusPin=1 then  			;is the the Mp-3 player still busy?

		inc WaitingMode 			;No, then move to Waiting for timer
		low MOSFEToutput			;turn off lights
		low EyesOutput  			;turn on TTL output
		read eepromTriggerDelay,word Temp_Word  ;reset time with neg number to wait  (Like -10 seconds)
		time=Temp_Word  			;write system time for ram variable
	endif
	
	return						;and exit

;This code waits for system time go from negative to a positive number (0 or greater)
	
FindTimesUp:
	
	if Time<255 then				;have it counted up from neg number?  255 is a safe pos number
		WaitingMode=WaitingForTrigger   	;reset the mode back to waiting for trigger.
	endif
	return


;Welcome to the Head movement code;  First up, we setup the movement for looking at someone.
;this code setup and move the head as if it is looking at your by tilting to one side, pause and back 
LookAt:

;Read in the head tilt data for Center min and max positions from eeprom storage
	read HeadTiltCenterPointer,CenterTiltPos,Temp_LSB,Temp_MSB ;(Center, min, max)

	MovementCount = Temp_MSB-Temp_LSB/3     	;get 1/3 of total range of tilt movement
	
	if TurnPos_MSB>CenterTurnPos then   		;Is the turn to the left of center position?
		TiltSpeed_Word=-256     		;yes, then tilt right (-1.00 speed)
	else
		TiltSpeed_Word=256      		;no, then tilt left (1.00)
	endif

	TurnSpeed_Word=0				;do only tilt in this position
	NodSpeed_Word=0 				;by clearing the Turn & nod speeds

	gosub RandomHeadSpeed   			;use random head speed for tilt

	gosub VectorMovement    			;tilt head

	Random Random_Word      			;get next random word and use it
	Temp_Word=Random_Word & 2047 + 500      	;random time delay of .5 to 3.047 seconds
	pause Temp_Word 				;pause for that time

	TiltSpeed_Word=0-TiltSpeed_Word 		;neg speed
	gosub	VectorMovement     		;and tilt head back

	Random Random_Word      			;get next random word and use it for
	Temp_Word=Random_Word & 2047 + 500      	;random time delay of .5 to 3.047 seconds
	pause Temp_Word 				;pause for that time

	return  					;and exit Tilt head movement.

symbol HeadTurnMinPointer=HeadTurnData+HeadMin  ;get the Min/Max of of Head turn position from eeprom

;This code move the head left/right a few times as if saying no
NodNo:
	
;Read in the head turn data for Center, min and max positions from eeprom storage
	read HeadTurnMinPointer,Temp_LSB,Temp_MSB ;(min, max pos of head turn) 
	if Temp_MSB<Temp_LSB then     		;is min larger that map position?
		swap Temp_LSB,Temp_MSB  		;yes, then swap them
	endif
	 
	MovementCount = Temp_MSB-Temp_LSB /4       ;Get 1/3 of distance from center to max turn position
	CenterTurnPos = Temp_MSB-Temp_LSB /2+Temp_LSB    ;get center of head nod (haft way point between min and max pos)

	if TurnPos_MSB>CenterTurnPos then       	;Make sure that the direction of the first movement is
		TurnSpeed_Word=-$100     		;is in the direction towards the center.
	else
		TurnSpeed_Word=$100     		;If current position is less than center that move positive.
	endif
	
	NodSpeed_Word=0 				;make sure the head does not move Nod or tilt
	TiltSpeed_Word=0				;by reseting their speeds.
	
	read HeadNodNoSpeed,MovementDelay       	;Get head shake no speed from eeprom storage.
	
	gosub VectorMovement    			;move head for first part of no
	
;now, setup for turn head back in other direction.	
	TurnSpeed_Word=-TurnSpeed_Word  		;Negative the speed
	MovementCount=MovementCount+MovementCount       ;and double the travel distances 
	gosub VectorMovement    			;and move the head
	
	TurnSpeed_Word=-TurnSpeed_Word  		;negative the direction again.
	gosub VectorMovement    			;and move head
	
	TurnSpeed_Word=-TurnSpeed_Word  		;negative the direction again
	gosub VectorMovement    			;and move head
	
	TurnSpeed_Word=-TurnSpeed_Word  		;negative the direction again
	gosub VectorMovement    			;and move head
	     
	TurnSpeed_Word=-TurnSpeed_Word  		;negative the direction again
	MovementCount=MovementCount/2   		;and cut the distance 1/2
	gosub VectorMovement    			;negative the direction again
	
	goto RandomPause				;go do a random wait and exit shake head no

;This code move the head back to the center postion and pauses there for a few seconds.
LookHome:
;get the center position for each axes and return to it
	read HeadTurnCenterPointer,NewTurnPos   	;get center turn position from eeprom storage.
;	gosub SetTurnVector     			;Set the Vector (speed) to -1 or 1 based on the direction of turn

	read HeadTiltCenterPointer,NewTiltPos   	;get the center Nod position from eeprom storage.
;	gosub SetTiltVector     			;Get the Detla of the vector for the Vector Head Tilt
	
	read HeadNodCenterPointer,NewNodPos     	;get center nod position from eeprom storage
;	gosub SetNodVector      			;Setup Head Nod vector based on final position of Turn
	gosub FindVectorDelta
	gosub RandomHeadSpeed   			;get readom speed of this movement.
	Gosub VectorMovement    			;move head to center position
	goto RandomPause				;go doa random wait and exit got to center position

;Makes head move to the far left
LookFarLeft:
	read HeadTurnCenterPointer,CenterTurnPos,Temp_MSB,Temp_LSB  ;(the min data in Temp_MSB is not used.)

	random Random_Word      			;move to next random number
	Temp_LSB = Temp_LSB-CenterTurnPos       	;get max size of turning left  (Max Turn) - (Center turn)
	temp_MSB = Random_LSB or $80    		;make sure the head left movement is 50% to 100% of the range
	Temp_Word = Temp_LSB*Temp_MSB   		;mul the range by random number from 0.5 to 0.99
	NewTurnPos = CenterTurnPos+Temp_MSB     	;get new random position to travel to
	
	if NewTurnPos = TurnPos_MSB then		;is this the same turn position?
		inc Random_LSB  			;change random so not to create a inf. loop
		goto LookFarLeft			;Get new random position if the same as old position
	endif
	goto SetupVectorMovement			;setup vector control and move head

;Makes head move to the near left
LookNearLeft:
	read HeadTurnCenterPointer,CenterTurnPos,Temp_MSB,Temp_LSB  ;(the min data in Temp_MSB is not used.)

	random Random_Word      			;move to next random number
	Temp_LSB = Temp_LSB-CenterTurnPos       	;get max distance of this movement (Max turn)-(center turn)
	temp_MSB = Random_LSB and $7F+10		;make sure the head left movement is <50% of the range
	Temp_Word = Temp_LSB*Temp_MSB   		;mul the range by random number from 0.05 to 0.55
	NewTurnPos = CenterTurnPos+Temp_MSB     	;get new random position to travel to
	
	if NewTurnPos = TurnPos_MSB then		;is this the same turn position?
		inc Random_LSB  			;yes, thenchange random so not to create a inf. loop
		goto LookNearLeft       		;and Get new random position if the same as old position
	endif
	
	goto SetupVectorMovement			;Setup vector movement and go do it.

;Makes head move Far right
LookFarRight:
	read  HeadTurnCenterPointer,CenterTurnPos,Temp_MSB  

	random Random_Word      		;move to next random number
	
	Temp_LSB = CenterTurnPos-Temp_MSB       ;get the range of this move right
	temp_MSB = Random_LSB or $80    	;make sure the head left movement is >50% of the range
	Temp_Word = Temp_LSB*Temp_MSB   	;mul the range by random number from 0.5 to 0.99
	NewTurnPos = CenterTurnPos-Temp_MSB     ;get new position to travel to
	
	if NewTurnPos = TurnPos_MSB then	;is this the save position as current?
		inc Random_LSB  		;yes,change random so not to create a inf. loop
		goto LookFarRight       	;Get new random position if the same as old position
	endif
	goto SetupVectorMovement		;setup vector movement and do head move

;Make head move to the right
LookNearRight:
	read	HeadTurnCenterPointer,CenterTurnPos,Temp_MSB  

	random Random_Word      		;move to next random number
	
	Temp_LSB = CenterTurnPos-Temp_MSB       ;get the random of this turn left move
	temp_MSB = Random_LSB and $7f+10	;make sure the head left movement is <50% of the range
	Temp_Word = Temp_LSB*Temp_MSB   	;mul the range by random number from 0.05 to 0.55
	NewTurnPos = CenterTurnPos-Temp_MSB     ;get new random position to tavle to
	
	if NewTurnPos = TurnPos_MSB then
		inc Random_LSB  		;change random so not to create a inf. loop
		goto LookNearRight      	;Get new random position if the same as old position
	endif
	goto SetupVectorMovement


GetTiltPos:
	
	read HeadTiltCenterPointer,CenterTiltPos	;get center tilt position
	read HeadTiltRate,Temp_MSB      		;get tilt rate for the head
	
	if NewTurnPos>CenterTurnPos then		;is new turn position to left of center?
	
		NewTiltPos=NewTurnPos-CenterTurnPos*Temp_MSB/256+CenterTiltPos ;How far right of center by
							; * the tilt rate /256 + center for new head tilt position
	else
		NewTiltPos=CenterTurnPos-NewTurnPos*Temp_MSB/256+CenterTiltPos ;How far left of center by
							; * the tilt rate /256 + center for new head tilt position
	endif
	
symbol HeadTiltMinPointer=HeadTiltData+HeadMin
	read HeadTiltMinPointer,Temp_LSB,Temp_MSB       ;get range of head tilt range  (Min,max)
	NewTiltPos=NewTiltPos min Temp_LSB max Temp_MSB
	return


GetNodPos:
	read HeadNodCenterPointer,CenterNodPos  	;Get Center Nod position
	read HeadNodRate,Temp_MSB       		;get tilt rate for the head
	read HeadTurnCenterPointer,CenterTurnPos

	if NewTurnPos>CenterTurnPos then		;is new turn position to left of center?
		NewNodPos=NewTurnPos-CenterTurnPos*Temp_MSB/256+CenterNodPos ;How far left of center by
							; * the tilt rate /256 + center for new held teli position
	else
		NewNodPos=CenterTurnPos-NewTurnPos*Temp_MSB/256+CenterNodPos ;How far left of center by
							; * the tilt rate /256 + center for new held teli position
	endif
	
	Random Random_Word      			;get a new random word
	Temp_Word=Random_LSB*30 			;Get a random number from 0-29 in MSB
	NewNodPos=NewNodPos+Temp_MSB-10 		;Take Random 0-29 and add to Nod paition and -10 for new Nod position

symbol HeadNodMinPointer=HeadNodData+HeadMin
	read HeadNodMinPointer,Temp_LSB,Temp_MSB	;get range of head tilt range
	NewNodPos=NewNodPos min Temp_LSB max Temp_MSB   ;Set new Head nod position within limits 
	return


RandomHeadSpeed:
	Random Random_Word      		;get a new random word
	read HeadDelayMin,Temp_LSB,Temp_MSB     ;get min delay and range of delay.
	MovementDelay = Temp_MSB-Temp_LSB * Random_LSB /256 + Temp_LSB  ; Random number of 0 to .99 times range plus min delay
	return  				;and exit
	
;Find the greatest delta (change in position) between the 3 servo's new position and use that for the
;number of steps to move head servos.
;Then div the delta of head movement vector by the greatest vector to find the "Speed" for each servo update.
FindVectorDelta:	
	if NewTurnPos>TurnPos_MSB then  		;Get the lenght of the turn servo vector and save it as new Delta
		TurnSpeed_LSB=NewTurnPos-TurnPos_MSB    ;make sure that it a positive number by doing the
	else
		TurnSpeed_LSB=TurnPos_MSB-NewTurnPos    ;correct sub between the current and new position
	endif
	MovementCount=TurnSpeed_LSB
	
	if NewNodPos>NodPos_MSB then    		;now, work on the Nod delta 
		NodSpeed_LSB=NewNodPos-NodPos_MSB
	else
		NodSpeed_LSB=NodPos_MSB-NewNodPos
	endif
	if NodSpeed_LSB>MovementCount then  		;save it if larger than the turn delta
		MovementCount=NodSpeed_LSB
	endif

	if NewTiltPos>TiltPos_MSB then  		;Now the Titlt servo
		TiltSpeed_LSB=NewTiltPos-TiltPos_MSB
	else
		TiltSpeed_LSB=TiltPos_MSB-NewTiltPos
	endif
	if TiltSpeed_LSB>MovementCount then  		;save it if larger than the other two deltas
		MovementCount=TiltSpeed_LSB
	endif
	MovementCount=MovementCount min 1       	;make sure it 1 or more
	
;Now that we got the max delta, we can use it to create the slope (speed) for each servo
	TurnSpeed_Word=TurnSpeed_LSB*256/MovementCount
	if NewTurnPos<TurnPos_MSB then
		TurnSpeed_Word=-TurnSpeed_Word
	endif
	NodSpeed_Word=NodSpeed_LSB*256/MovementCount
	if NewNodPos<NodPos_MSB then
		NodSpeed_Word=-NodSpeed_Word
	endif
	
	TiltSpeed_Word=TiltSpeed_LSB*256/MovementCount
	if NewTiltPos<TiltPos_MSB then
		TiltSpeed_Word=-TiltSpeed_Word
	endif
	return



SetupVectorMovement:
	gosub GetTiltPos			;setup the Tilt based on the new head turn position
	gosub GetNodPos
	gosub FindVectorDelta
	gosub RandomHeadSpeed
	gosub VectorMovement

;Random Pause after movement
RandomPause:
	Random Random_Word      		;get next random number
	Temp_Word= Random_Word and 2047 + 500   ;Get random 0 to 2.047 seconds Plus 0.5 seconds
	Pause Temp_Word 			;pase for that random time
	return

	
;This is the general code for moving the head from one point to another
;It will move from left/right (turn), Tilt and Nod.
;Inertia is simulated for more life like head movement with weight.
;Head left/right movement (Turn) is a 8-bit integer number.
;Head Nod and Tilt use a 16-bit fix point number with the decimal point between the LSB and the MSB
;code does a servo range limit check to keep the servos from burning out or breaking the 3-axes system

VectorMovement:
	if MovementCount> 8 then		;Moving a short distance of 8 or less?
		Inertia=MovementDelay*8 	;No, then set start inertia so head has weight
	else
		Inertia=4       		;else start inertia at 4 for short distance
	endif
	
	LastTurn=TurnPos_MSB    		;Save the current Turn, Tilt and Nod Servo positions
	LastTilt=TiltPos_MSB    		;so we know to update the servos as needed because
	LastNod=NodPos_MSB      		;updating the servos too offen may cahse jitter.

	For VectorIndex = MovementCount to 1 step -1    ;start loop by counting backwares

;Now the Turn Head code
	TurnPos_Word=TurnPos_Word+TurnSpeed_Word ;Add 8-bit integer delta to Head Turn Position
	
	read HeadTurnMinPointer,Temp_LSB,Temp_MSB       ;Temp_LSB=min and Temp_MSB=max positions
TurnPos_MSB=TurnPos_MSB min Temp_LSB max Temp_MSB

	if LastTurn != TurnPos_MSB then 	;did position change?
		LastTurn=TurnPos_MSB    	;yes, then note new position for next time
		servopos HeadTurnServo,TurnPos_MSB  ;Put integer number of head turn into turn servo
	endif
	
;Now for the Nod head code
	NodPos_Word=NodPos_Word+NodSpeed_Word   ;Add 16-bit (fix pointer) delta to Head Nod Position

	read HeadNodMinPointer,Temp_LSB,Temp_MSB	;Temp_LSB=min and Temp_MSB=max positions
NodPos_MSB=NodPos_MSB min Temp_LSB max Temp_MSB

	if NodPos_MSB != LastNod then   	;did position change?
		LastNod=NodPos_MSB      	;yes, then note new position for next time
		servopos HeadNodServo,NodPos_MSB  ;Put whole number (top 8 bits) of head Nod into servo
	endif
	
;Now for the Tilt Head code
	TiltPos_Word=TiltPos_Word+TiltSpeed_Word  ;Add 16-bit (fix pointer) delta to Head Tilt Position
	read HeadTiltMinPointer,Temp_LSB,Temp_MSB ;get the Min/Max of of Head Tilt from eeprom

TiltPos_MSB=TiltPos_MSB min Temp_LSB max Temp_MSB

	if LastTilt != TiltPos_MSB then 	;did position change?
		LastTilt=TiltPos_MSB    	;yes, then note new position for next time
		servopos HeadTiltServo,TiltPos_MSB  ;Put whole number (Top 8-bits) of head Tilt into servo
	endif
	
;inertia code for the near end of movement
	if VectorIndex<10 then   		;Are getting close to stopping? (10)
		Inertia=MovementDelay/2+Inertia  ;yes, then increase Inertia to slow down head movement
	else
;remove Start inertia factor	
		Inertia=Inertia/2       	;NO, then Start cutting Inertia by 50% (At some point it will be zero)
	endif

	Temp_Word=MovementDelay+Inertia  	;Get base speed plus Inertia

	if WaitingMode=WaitingForNotBusy then   ;Are we in talking mode?
		Temp_Word=Temp_Word*3/4   	;yes, then head move at 25% faster.
	endif
 
	pause Temp_Word 			;Now wait for that time to controll the speed of head movement.

	Random Random_Word      		;make random a bit more random by calling in this loop	
	Next VectorIndex			;loop back if till movement is done
	return  				;and exit.

;This code handle talking to the MP-3 player module via the pin marked MP3SerialOutPort
;the speed is set to 4800 baud at 16 MHz CPU clock

;This is used to Talking with a long 1 second delay for the busy line to come true
DoTalkCommand:
;	serout MP3SerialOutPort,T4800_16,(Temp_MSB)     ;send out sound command
	hserout 0,(Temp_MSB)    		;send out sound command
	Temp_MSB=0  				;clear sound command
	pause 2000  				;wait 1.00 seconds for Busy to show true status
	return  				;and exit
;Talk to the MP-3 plyaer with a fast 130 ms delay on exit
DoSFXCommand:
;	serout MP3SerialOutPort,T4800_16,(Temp_MSB)     ;send out sound command
	hserout 0,(Temp_MSB)    		;send out sound command
	Temp_MSB=0      			;clear sound command
	pause 250       			;pause for a short 0.13 ms delay
	return  				;and exit

;This waits for the MP-3 player to be nolonger busy and then exits
WaitForSFXDone:
	if MP3StatusPin=0 then WaitForSFXDone   ;Loop if busy
	return  				;exit if not.


;Now for the menu section to setup the servo limits and board options
;This part of the program uses the SETUP button and potentiometer to
;select items or set the servo limits.  The PROGRAM LED will turn on
;while in this mode. The MP-3 will use voice promts to tell the user
;what to do.

StartSetup:
	High  SetupLED  		;Turn on LED to show we are in SETUP mode
	Temp_MSB=MP3MenuFolder  	;select the audio folder that holds tracks for Menu audio
	gosub DoSFXCommand
	
	Temp_MSB=TalkSetupWelcome       ;Say welcome to the SETUp menu
	gosub DoTalkCommand
	gosub WaitForSFXDone    	;wait till done talking
	gosub WaitForUnPress    	;make sure the buttun is no longer pressed

;The main menu loop
SetupMenu:
	DataPointer=eepromMenuBase      ;get Start Setup menu dataset
;and fall into the menu system

GetMenuInput:
	ElapsedTime=0   		;reset the repeat timer  (Use to repeat prompt if user takes too long.)
;DataPointer "pointer" to where in the EEPROM is the data record for this menu
;TalkNumber is the main vocal prompt for this menu (Tells user what to do.)
;CodeToRun is the what to code do after item is selected by user.
;ItemCount is the number of items in this menu.
;TalkItem is the vocal prompt of the first item number of this menu

	Read DataPointer,TalkNumber,CodeToRun,ItemCount,TalkItem	;get this menu's data record

	LastItemNumber=255      	;set last Item Nubmer to bad number so it will speak the itemright away
	Temp_MSB=TalkNumber     	;Tell user what to do
	gosub DoTalkCommand     	;speak it
	pause 2000
	gosub WaitForSFXDone    	;Wait for the volcal prompt to end
	gosub WaitForUnPress    	;make sure the button is no loger press
	readadc SetupPot,LastPotReading ;get ADC from setup pot position and show as last time
	
GetMenuInputLoop:
;By calling RANDOM command while we wait for user input, we advance the pseudo random number generator.
;Since the number times RANDOM command will be called will very based on how how long the user takes to
;push the button, we move to a random point in the random number generator list.
;This basically makes the random command more random by creating a "Random Seed" or pointer to the
;random list of number it creates.
	Random Random_Word      	;make random a bit more random

;Next, read the Proramming Pot to find the user selected item.
	readadc SetupPot,PotRead			;get ADC from setup pot position
;Now average the read with the reading from last time to help remove jitter.
	LastPotReading=LastPotReading+PotRead/2 	;remove jitter
;This will convert the 0 to 255 range of the Pot to just the range of items in the menu
	ItemNumber=LastPotReading*ItemCount/256 	;convert 0-255 to 0 - (n-1)

;See if the user input on the Pot had change the item number
	if ItemNumber<>LastItemNumber then      ;is the last item the same as this time?

		LastItemNumber=ItemNumber       ;yes, then change the "Last" item number to this
		Temp_MSB=TalkItem+Itemnumber    ;get vocal prompt for this menu item
		gosub DoTalkCommand     	;and tell MP-3 player to play the MP-3 file for it
		ElapsedTime=0   		;reset the elapsed timer so not to repear again for 30 second
		
	endif

;We want to remind the user what menu we are in and what they should be doing
;Repear the vocal prompt if there has been not change in the item selection for 30 seconds
	if ElapsedTime>30 then goto GetMenuInput	;restart input item if over 30 seconds since last change
	
	if SetupButtonPin=0 then goto GetMenuInputLoop  ;if button pressed? No, then keep doing the loop
	
;With button presses, let say item "Selected"
	Temp_MSB=TalkItem+Itemnumber    ;get talk for this item
	gosub DoTalkCommand     	;Play MP-3 file
	gosub WaitForSFXDone    	;wait till done speaking

	Temp_MSB=TalkSelected   	;get "selected"
	gosub DoTalkCommand     	;speak it
	gosub WaitForSFXDone    	;wait for it to complete

	gosub WaitForUnPress    	;make sure the button is no longer pressed

;Now, run the code to process this the function of this menu
	on CodeToRun goto RunSetupMenu, RunBoardOptionsMenu, RunTrackMenu, RunDelayMenu, RunTriggerMenu

;Next up are the functions to run after the user select the item from the menu
;First is the what to to do have the main Setup Menu
RunSetupMenu:
	if ItemNumber=0 then ServoSetup 	;the first item was setting the limits of the servos
	if ItemNumber=1 then StartBoardMenu     ;Was it the second item for board options menu?
			
;The third item was exit the Main setup menu and restart the board to run the head movement stuff
ExitSetMenu:
;Write to the eeprom the new random seed to help make RANDOM command more random on next power up
	write eepromRandomSeed,word Random_Word    ;Let's write random in random seed in the eeprom
	
	Temp_MSB=TalkEndSetupMenu       ;Get vocal prompt for exiting the Setup menu
	gosub DoTalkCommand     	;speak it
	gosub WaitForSFXDone    	;wait till done speaking
	goto  StartHeadMovement 	;and go start the head movement code

StartBoardMenu:
	DataPointer=eepromBoardMenu     ;yes, the get the data record for the Board Options Menu
	goto GetMenuInput       	;and start the Board Options Menu

;Now we have what to do after the Board Options Menu
RunBoardOptionsMenu:
	if ItemNumber= 4 then SetupMenu 	;The last item was go back to return to the main Setup Menu
	DataPointer=ItemNumber*4+eepromBoardMenu+4      ;get Get the data record based on item number
	goto GetMenuInput       		;and go run that menu

;This code selects the number of tracks to use during head movement
RunTrackMenu:
	inc ItemNumber  			;Convert 0-9 to 1-10
	write eepromTrackCount,ItemNumber       ;save it in the eeprom storage for the number of tracks to use
	goto StartBoardMenu     		;return the Board Options Menu.

;This will get a 16-bit time delay based on the Item number.
RunDelayMenu:
	ItemNumber=ItemNumber*2+eepromTimeIndexTable    ;get 16-bit index to the time to wait before triggering.
	read ItemNumber,word Temp_word  		;get the negative time  -(time index)
	write eepromTrackCount,Temp_Word		;store into EEPROM storage
	goto StartBoardMenu     			;go back to Board Option Menu
;Get the type of trigger the board should use based on the Item number
RunTriggerMenu:
	write eepromTriggerType,ItemNumber      ;Write Item number in the eeprom stroage of Trigger type
	goto StartBoardMenu     		;return to the Board Options Menu


;Time to set the center position and limits of all 3 movement servos
;a data record is used to control the setting ove each servo.  the format is...
;TalkNumber     The vocal prompt for tis servo
;ThisServo      The code number (0-2) for the servo
;ThisServoPin   The I/O pin the servo is connect to the Picaxe chip
;ThisEEPROM     The eeprom record to store the new center position and limits
ServoSetup:
	Temp_MSB=TalkSetupServos	;vocal prompt for what the user is to do
	gosub DoTalkCommand     	;speak it
	gosub WaitForSFXDone    	;Wait till MP-3 player is done talking
	DataPointer=eepromSetServoData  ;get first data record (Nod servo)

DoThisServo:
	gosub MakePotCenter     	;make sure the pot is in near the center position
	gosub WaitForUnPress    	;make sure the button is no loger press
	Read DataPointer,TalkNumber,ThisServo,ThisServoPin,ThisEEPROM   ;get this input data

	readadc SetupPot,PotRead	;get ADC from setup pot position
	ItemNumber=PotRead*ServoRange/256+ServoMin ;Convert input of 0-255 to range for Servo
	Servo ThisServoPin,ItemNumber   ;start servo
	LastItemNumber=255      	;Reset Last item so not to match the next servo number

	Temp_MSB=TalkNumber     	;Tell user what what servo we are working on
	gosub DoTalkCommand     	;speak it
	gosub WaitForSFXDone    	;Wait till done talking
	inc TalkNumber  		;move talk number to the voice prompt of adjusting servo

	for ServoCounter=1 to 3 	;start loop for the adjustments of Center Min and Max position

DoThisServoTalk:
	ElapsedTime=0   		;reset the repeat timer (used to remind user what to do.)

	Temp_MSB=TalkNumber     	;Tell user what they are adjusting for
	gosub DoTalkCommand     	;speak it
	gosub WaitForUnPress    	;make sure the button is no loger press
	readadc SetupPot,LastPotReading ;get ADC from setup pot position

DoThisServoLoop:
	Random Random_Word      	;make random a bit more random by calling during user input loop
	readadc SetupPot,PotRead	;get ADC from setup pot position
;Now average the read with the reading from last time to help remove jitter.
	LastPotReading=LastPotReading+PotRead/2 	;remove jitter.
;Convert the 0-255 range to the limits of the servo
	ItemNumber=LastPotReading*ServoRange/256+ServoMin ;get input range for Servo
	if ItemNumber<>LastItemNumber then      ;is the servo position the same as last time?
	
		LastItemNumber=ItemNumber       ;no, then use tnis new servo position
		gosub UpdateServo       	;update servo position based on servo number
		pause 100       		;delay 50 ms to slow done how fast we update the servo.
		ElapsedTime=0   		;reset the repeat timer
	endif

	if ElapsedTime>30 then goto DoThisServoTalk	;Tell user what they doing if over 30 seconds since last change
	
	if SetupButtonPin=0 then goto DoThisServoLoop	;if button pressed? No, then keep doing the loop
	
	write ThisEEPROM,ItemNumber     ;record this servo position in eeprom storeage.
 
	inc TalkNumber  		;move to next voice promp
	inc ThisEEPROM  		;move to next EEPROM location to record
	gosub WaitForUnPress    	;make sure the button is no loger press
	next ServoCounter       	;and do next for/next loop on this servo

;Return the servo to the center poistion by reading the data out of the last record of the eeprom
	Temp_LSB=ThisEEPROM-3   	;get Center position for servo we just adjusted.
	Read Temp_LSB,ItemNumber	;read it from eeprom
	gosub UpdateServo       	;update servo position to center

;make sure the Min pos of servo is large than the max position of servo
	ItemNumber=ThisEEPROM-2   	;get min & max positions for servo we just adjusted.
	Read ItemNumber,Temp_LSB,Temp_MSB	;read it from eeprom
	if Temp_LSB>Temp_MSB then     	;is the min pos larger than the max? 
		swap Temp_LSB,Temp_MSB  	;Yes then swap them
		write ItemNumber,Temp_LSB,Temp_MSB  ;and write it back to the eeprom for this servo
	endif
	
	DataPointer=DataPointer+4       ;move to next servo menu record to work on  (4 bytes per record)
	if DataPointer<eepromMenuBase then DoThisServo ;loop if all 3 have not been done.

	Temp_MSB=TalkEndServoSetup      ;tell user that all the servos are done.
	gosub DoTalkCommand     	;speak it if there is sound command

;this next section check to make sure that the min and max are in that order for turn servo
;if there are backwards, it will swap them in the eeprom.
symbol PointerHeadTurnMin=EEPROMHeadTurn+HeadMin
	read PointerHeadTurnMin,word Temp_Word  ;get the min and max for head turn.
	if Temp_MSB<Temp_LSB    then    	;is the Min > Max?
		write PointerHeadTurnMin,Temp_MSB,Temp_LSB      ;yes, then swap them in the eeprom
	endif

	gosub WaitForSFXDone    		;wait till done talking
	gosub WaitForUnPress    		;make sure the button is no loger press
	goto StartSetup 			;return to main setup menu

;MakePotCenter: Tell user to center the pot before moving on.
MakePotCenter:
	readadc SetupPot,PotRead		;get ADC from setup pot position
	if PotRead>CenterMinPot and PotRead<CenterMaxPot then  ;is it near center position?
		return  			;if so, then exit now
	endif
MakePotCenterTalk:
	ElapsedTime=0   			;reset the repeat timer
	Temp_MSB=TalkCenterPot  		;Get talk for telling user to center pot
	gosub DoTalkCommand     		;Speak about center pot

MakePotCenterLoop:
	Random Random_Word      		;make random more random
	readadc SetupPot,PotRead		;get ADC from setup pot position
	if PotRead>CenterMinPot and PotRead<CenterMaxPot then   ;is it in center range?

		Temp_MSB=TalkThankYou   	;Yes? then Say Thank you
		gosub DoTalkCommand     	;speak it via the sound command
		gosub WaitForSFXDone    	;wait till done talking
		return  			;and exit
	endif

	if ElapsedTime>7 then goto MakePotCenterTalk ;restart input item if over 7 seconds since last vocal prompt
	goto MakePotCenterLoop  		;else just loop
	
;Wait for the button to unpressed for 25 ms.
WaitForUnPress:
	Temp_LSB=25     		;get time to count for released button (25 ms)
	
WaitForUnPressLoop:
	Random Random_Word      	;make random more random
	pause 1 			;wait one ms
	if SetupButtonPin=1 then WaitForUnPress  ;if button still pressed? Yes then reset the loop counter and loop
	dec Temp_LSB    		;else count down by 1
	if Temp_LSB>0 then WaitForUnPressLoop ;loop if 25 ms has not gone by.
	Return  			;else exit
	
;This code talks to a one of three servos based on servo number 0-2
;The Servopos command only uses a constant for what B port pin to use.
;Since the servo setting menu needs a variable to select what B port to use,
;We select between 3 Servopos commands to used via On goto statement.
UpdateServo:
	on ThisServo goto UpdateServo0,UpdateServo1,UpdateServo2

UpdateServo0:
	servopos HeadTurnServo,ItemNumber       ;Set position of first (turn) servo
	return
UpdateServo1:	
	servopos HeadNodServo,ItemNumber	;Set position of second (Nod) servo
	return
UpdateServo2:	
	servopos HeadTiltServo,ItemNumber       ;set position of third (Tilt) Servo
	return
	
